Attribute VB_Name = "FedEx_FSMS"
Dim fsmsServerIP As String, fsmsServerPort As Integer

Dim fsmsStr(10) As String
Dim fsmsInt(10) As Integer

Sub Initialize()
    fsmsStr(0) = IniRead(CS32.ShipDir & "CS_MAIN.INI", "DirectorySetup", "FedEx", CS32.ShipDir & "FDX") & "\"
    fsmsServerIP = IniRead(fsmsStr(0) & "FDX.ini", "Server", "FdxServerAddress", IniRead(NetDir & "FSMS\FSMS.ini", "Server", "IP", ""))
    fsmsServerPort = IniRead(fsmsStr(0) & "FDX.ini", "Server", "FdxServerPort", IniRead(NetDir & "FSMS\FSMS.ini", "Server", "Port", "2000"))
    
        
End Sub

Sub RouteRequest()
    Dim sFsmsTrans As String
    Dim sSvcCode As String
    
    sSvcCode = FedEx_FSMS.GetServiceCode("US", CS32.GetVar("xINTCODE"), CS32.GetVar("xUSE_RES"))
    
    FSMS.Server = fsmsServerIP
    FSMS.Port = fsmsServerPort
    
    FSMS.Start
    FSMS.ShowStatus = True
    
    FSMS.BeginTrans 20
    FSMS.SetFieldValue 1, Trim(CS32.GetVar("xPKGID"))
    FSMS.SetFieldValue 16, Right(Trim(CS32.GetVar("xSHIPTO7")), 2)
    FSMS.SetFieldValue 17, Trim(CS32.GetVar("xZIP"))
    FSMS.SetFieldValue 23, "1"
    FSMS.SetFieldValue 24, DtoS(CtoD(CS32.GetVar("xDATE")), "yyyymmdd")
    FSMS.SetFieldValue 50, "US"
    FSMS.SetFieldValue 1234, "2"
    FSMS.SetFieldValue 1273, "01"
    FSMS.SetFieldValue 1274, sSvcCode
    FSMS.SetFieldValue 1670, Roundup(CDbl(CS32.GetVar("xACT_WGT")) * 100, 1)
    FSMS.SetFieldValue 99, ""
    FSMS.EndTrans
    
    fsmsStr(0) = FSMS.GetFieldValue(409)
    If fsmsStr(0) <> "ERROR" Then
        fsmsStr(1) = Upper(SubStr(fsmsStr(0), 3, 3)) & "/" & SubStr(fsmsStr(0), 1, 2) & "/" & SubStr(fsmsStr(0), 6, 2)
        fsmsStr(1) = StrTran(fsmsStr(1), "JAN", "01")
        fsmsStr(1) = StrTran(fsmsStr(1), "FEB", "02")
        fsmsStr(1) = StrTran(fsmsStr(1), "MAR", "03")
        fsmsStr(1) = StrTran(fsmsStr(1), "APR", "04")
        fsmsStr(1) = StrTran(fsmsStr(1), "MAY", "05")
        fsmsStr(1) = StrTran(fsmsStr(1), "JUN", "06")
        fsmsStr(1) = StrTran(fsmsStr(1), "JUL", "07")
        fsmsStr(1) = StrTran(fsmsStr(1), "AUG", "08")
        fsmsStr(1) = StrTran(fsmsStr(1), "SEP", "09")
        fsmsStr(1) = StrTran(fsmsStr(1), "OCT", "10")
        fsmsStr(1) = StrTran(fsmsStr(1), "NOV", "11")
        fsmsStr(1) = StrTran(fsmsStr(1), "DEC", "12")
        CS32.SetVar "xVDC_PHONE", DtoS(CtoD(fsmsStr(1)))
    Else
        fsmsInt(0) = CInt(FSMS.GetFieldValue(3058))
        If fsmsInt(0) > 0 Then
            XD1 = FedEx_FSMS.GetDeliveryDate(CtoD(CS32.GetVar("xDATE")), fsmsInt(0), sSvcCode)
            
            CS32.SetVar "xVDC_PHONE", DtoS(XD1)
        End If
    End If
    
    FSMS.Terminate
    
End Sub

Function GetServiceCode(ByVal sFromCountry As String, ByVal sIntcode As String, Optional ByVal sResFlag As String = "N") As String
    Dim sSvcCode As String
    
    If sFromCountry = "US" Then
        Select Case sIntcode
            Case "F01", "F02", "F03", "F04", "F05"
                sSvcCode = "01"
            Case "F06", "F07", "F08", "F09", "F10"
                sSvcCode = "05"
            Case "F11", "F20", "F21", "F35", "F36"
                sSvcCode = "03"
            Case "F14", "F33", "F34"
                sSvcCode = "20"
            Case "F18", "F19", "F30", "F31", "F32"
                sSvcCode = "06"
            Case "F37", "F38", "F39", "F40", "F41"
                sSvcCode = "49"
            Case "F60", "F61", "F62", "F81", "F82"
                sSvcCode = "06"
            Case "F63", "F64", "F65", "F71", "F72", "F76", "F77"
                sSvcCode = "01"
            Case "F69", "F78", "F79", "F80"
                sSvcCode = "20"
            Case "R02"
                If sResFlag = "Q" Then
                    sSvcCode = "90"
                Else
                    sSvcCode = "92"
                End If
        End Select
    End If
            
    GetServiceCode = sSvcCode
End Function

Function GetDeliveryDate(ByVal dtShipDate As Date, ByVal iTransitDays As Integer, ByVal sServiceCode As String)
    Dim dtDeliveryDate As Date
    
    Do While Not IsPickupDay(dtShipDate, sServiceCode)
        dtShipDate = dtShipDate + 1
    Loop
    
    dtDeliveryDate = dtShipDate
    Do While iTransitDays > 0
        dtDeliveryDate = dtDeliveryDate + 1
        If IsTransitDay(dtDeliveryDate, sServiceCode) Then
            iTransitDays = iTransitDays - 1
        End If
    Loop
    GetDeliveryDate = dtDeliveryDate
End Function

Function IsPickupDay(ByVal dtShipDate As Date, ByVal sServiceCode) As Boolean
    Dim iWeekDay As Integer
    
    iWeekDay = Weekday(dtShipDate)
    IsPickupDay = True
    If iWeekDay = 1 Or iWeekDay = 7 Then
        IsPickupDay = False
    End If
    If IsPickupDay Then
        IsPickupDay = Not IsHoliday(dtShipDate)
    End If
End Function
Function IsTransitDay(ByVal dtShipDate As Date, ByVal sServiceCode) As Boolean
    Dim iWeekDay As Integer
    
    iWeekDay = Weekday(dtShipDate)
    IsTransitDay = True
    If sServiceCode = "90" Then
        'Home Delivery doesn't deliver on Monday or Tuesday.
        If (iWeekDay = 1 Or iWeekDay = 2) Then
            IsTransitDay = False
        End If
    Else
        'FedEx std services don't deliver on Saturday or Sunday.
        If (iWeekDay = 1 Or iWeekDay = 7) Then
            IsTransitDay = False
        End If
    End If
    If IsTransitDay Then
        IsTransitDay = Not IsHoliday(dtShipDate)
    End If
    
End Function

Function IsHoliday(ByVal dtShipDate As Date) As Boolean
    IsHoliday = False
    If Month(dtShipDate) = 1 Then
    'Check for New Years.
        If Day(dtShipDate) = 1 Then
            IsHoliday = True
        End If
    ElseIf Month(dtShipDate) = 5 Then
    'Check for Memorial Day.
    'Day = Monday, and within last 7 days of month.
        If Weekday(dtShipDate) = 2 And Day(dtShipDate) >= 25 Then
            IsHoliday = True
        End If
    ElseIf Month(dtShipDate) = 7 Then
    'Check for 4th of July
        If Day(dtShipDate) = 4 Then
            IsHoliday = True
        End If
    ElseIf Month(dtShipDate) = 9 Then
    'Check for Labor Day.
    'Day = Monday, and within first 7 days of month.
        If Weekday(dtShipDate) = 2 And Day(dtShipDate) <= 7 Then
            IsHoliday = True
        End If
    ElseIf Month(dtShipDate) = 11 Then
    'Check for Thanksgiving.
    'Day = Thursday and within 4th week of month (22-28th)
        If Weekday(dtShipDate) = 5 And (Day(dtShipDate) >= 22 And Day(dtShipDate) <= 28) Then
            IsHoliday = True
        End If
    ElseIf Month(dtShipDate) = 12 Then
    'Check for Christmas
        If Day(dtShipDate) = 25 Then
            IsHoliday = True
        End If
    End If
End Function
