Attribute VB_Name = "RateShop"
Dim rsInitialized As Boolean
Dim rsEnabled As Boolean
Dim rsDir As String

Dim rsStr(10) As String, rsInt(10) As Integer, rsDbl(10) As Double

Public Type RateShopResult
    ID As String
    Weight As Double
    Length As Double
    Width As Double
    Height As Double
    Zip As String
    UpsService As String
    UpsRate As Double
    FedExService As String
    FedExRate As Double
End Type

Public Result As RateShopResult
Public Rating As Boolean

Function Initialize()
    Initialize = rsInitialized
    If rsInitialized Then
        Exit Function
    End If
    
    Rating = False
    
    rsDir = CS32.ShipDir & "Logic\RateShop"
    
    If Dir(rsDir, vbDirectory) = "" Then
        MkDir rsDir
    End If
    rsDir = rsDir & "\"
        
    If Dir(rsDir & "XML", vbDirectory) = "" Then
        MkDir rsDir & "XML"
    End If
    
    rsTmpDir = RunDir & "RateShop"
    If Dir(rsTmpDir, vbDirectory) = "" Then
        MkDir rsTmpDir
    End If
    rsTmpDir = rsTmpDir & "\"
    
    If Dir(rsTmpDir & "Temp", vbDirectory) = "" Then
        MkDir rsTmpDir & "Temp"
    End If
    
    rsStr(0) = Left(Upper(IniRead(rsDir & "RateShop.ini", "Settings", "Enabled", "")), 1)
    If KiEmpty(rsStr(0)) Then
        rsStr(0) = "N"
        IniWrite rsDir & "RateShop.ini", "Settings", "Enabled", rsStr(0)
    End If
    rsEnabled = (rsStr(0) = "Y")
    
    rsInitialized = True
    Initialize = rsInitialized
End Function

Sub Rate(ByVal iMode As Integer, ByVal sDeliverByDate As String)
    rsInitialized = Initialize()
    If Not (rsInitialized And rsEnabled) Then
        Exit Sub
    End If
    
    rsStr(1) = Trim(CS32.GetVar("xPKGID"))
    rsStr(2) = Trim(CS32.GetVar("xZIP"))
    rsDbl(1) = Val(CS32.GetVar("xACT_WGT"))
    rsDbl(2) = Val(CS32.GetVar("xDIM_LENGTH"))
    rsDbl(3) = Val(CS32.GetVar("xDIM_WIDTH"))
    rsDbl(4) = Val(CS32.GetVar("xDIM_HEIGHT"))
    
    If Result.ID = rsStr(1) And Result.Zip = rsStr(2) And Result.Weight = rsDbl(1) _
        And Result.Length = rsDbl(2) And Result.Width = rsDbl(3) _
        And Result.Height = rsDbl(4) And Result.UpsRate > 0 And Result.FedExRate > 0 Then
        Exit Sub
    End If
    
    Result.ID = rsStr(1)
    Result.Zip = rsStr(2)
    Result.Weight = rsDbl(1)
    Result.Length = rsDbl(2)
    Result.Width = rsDbl(3)
    Result.Height = rsDbl(4)
    Result.UpsService = ""
    Result.UpsRate = 0
    Result.FedExService = ""
    Result.FedExRate = 0
    
    Dim sOrigSvc As String
    
    Rating = True
    
    sOrigSvc = Trim(CS32.GetVar("xCARRIER"))
    If iMode = 1 Then
        Dim sUpsSvcs As String, sFdxSvcs As String
        sUpsSvcs = IniRead(rsDir & "RateShop.ini", "Settings", "UPSList", "")
        sFdxSvcs = IniRead(rsDir & "RateShop.ini", "Settings", "FedExList", "")
        
        RateServices sUpsSvcs, sDeliverByDate
        RateServices sFdxSvcs, sDeliverByDate
    Else
        RateServices sOrigSvc
        
        rsStr(0) = IniRead(rsDir & "RateShop.ini", "", sOrigSvc, "")
        If Not KiEmpty(rsStr(0)) Then
            RateServices rsStr(0)
        End If
    End If
    CS32.SetVar "xCARRIER", sOrigSvc
    Rating = False
    
    rsStr(0) = "Result.ID=" & Result.ID & "; " & _
        "Result.Zip=" & Result.Zip & "; " & _
        "Result.Weight=" & Result.Weight & "; " & _
        "Result.Length=" & Result.Length & "; " & _
        "Result.Width=" & Result.Width & "; " & _
        "Result.Height=" & Result.Height & "; " & _
        "Result.UpsService=" & Result.UpsService & "; " & _
        "Result.UpsRate=" & Result.UpsRate & "; " & _
        "Result.FedExService=" & Result.FedExService & "; " & _
        "Result.FedExRate=" & Result.FedExRate

    kiDebug rsStr(0), ProjectDir & "Debug.log", "RateShop.Rate()"
    
End Sub

Private Sub RateServices(ByVal sServices As String, Optional ByVal sDeliverByDate As String = "")
    Dim i As Integer
    i = 0
    Do While True
        i = i + 1
        
        Dim sSvc As String
        sSvc = SubToken(sServices, (i), ";")
        If KiEmpty(sSvc) Then
            Exit Do
        End If
        
        Dim dblTotChg As Double
        Dim sIntCode As String
        Dim sDeliverDate As String
        
        CS32.SetVar "xCARRIER", sSvc
        CS32.RateTrans
        CS32.Clippership_AfterCarrierRate
        
        sIntCode = Trim(CS32.GetVar("xINTCODE"))
        dblTotChg = Val(CS32.GetVar("xTOT_CHG"))
        sDeliverDate = Trim(CS32.GetVar("xVDC_PHONE"))
        
        If dblTotChg > 0 And (KiEmpty(sDeliverByDate) Or Not KiEmpty(sDeliverDate)) Then
            Dim bContinue As Boolean
            bContinue = True
            
            'If delivery by date is provided, make sure service meets delivery requirement.
            If Not KiEmpty(sDeliverByDate) Then
                bContinue = False
                
                Dim dtDeliverBy As Date, dtDeliver As Date
                
                dtDeliver = CtoD(SubStr(sDeliverDate, 5, 2) & "/" & SubStr(sDeliverDate, 7, 2) & "/" & Left(sDeliverDate, 4))
                dtDeliverBy = CtoD(SubToken(sDeliverByDate, 1, " "))
                
                If (dtDeliver > dtDeliverBy) Then
                    bContinue = True
                End If
            End If
            
            If bContinue Then
                If Left(sIntCode, 1) = "U" Then
                    If (dblTotChg < Result.UpsRate Or Result.UpsRate = 0) Then
                        Result.UpsRate = dblTotChg
                        Result.UpsService = sSvc
                    End If
                ElseIf Left(sIntCode, 1) = "F" Or Left(sIntCode, 1) = "R" Then
                    If (dblTotChg < Result.FedExRate Or Result.FedExRate = 0) Then
                        Result.FedExRate = dblTotChg
                        Result.FedExService = sSvc
                    End If
                End If
            End If
        End If
    Loop
End Sub
