Attribute VB_Name = "UpsAPI"
Dim upsInitialized As Boolean
Dim upsApiEnabled As Boolean

Dim upsApiUsername As String
Dim upsApiPassword As String
Dim upsApiKey As String

Dim upsTntRq As String, upsTntRs As String
Dim upsRateRq As String, upsRateRs As String
Dim upsServer As String
Dim upsDir As String, upsTmpDir As String

Dim upsStr0 As String, upsStr1 As String, upsStr2 As String, upsStr3 As String, upsStr4 As String, upsStr5 As String
Dim upsNum0 As Variant, upsNum1 As Variant, upsNum2 As Variant, upsNum3 As Variant, upsNum4 As Variant, upsNum5 As Variant
Dim upsFileNum0 As Integer, upsFileNum1 As Integer, upsFileNum2 As Integer

Dim upsStr(10) As String
Dim upsInt(10) As Integer

Dim upsResponseXml As MSXML2.DOMDocument60

Function UPS_Initialize()
    UPS_Initialize = upsInitialized
    If upsInitialized Then
        Exit Function
    End If
    
    upsDir = CS32.ShipDir & "Logic\UPSAPI"
    
    If Dir(upsDir, vbDirectory) = "" Then
        MkDir upsDir
    End If
    upsDir = upsDir & "\"
        
    If Dir(upsDir & "XML", vbDirectory) = "" Then
        MkDir upsDir & "XML"
    End If
    
    upsTmpDir = RunDir & "UPS"
    If Dir(upsTmpDir, vbDirectory) = "" Then
        MkDir upsTmpDir
    End If
    upsTmpDir = upsTmpDir & "\"
    
    If Dir(upsTmpDir & "Temp", vbDirectory) = "" Then
        MkDir upsTmpDir & "Temp"
    End If
    
    WinExec upsDir & "CleanupXml.vbs"
    
    upsStr(0) = Left(Upper(IniRead(upsDir & "UPSAPI.ini", "Settings", "Enabled", "")), 1)
    If KiEmpty(upsStr(0)) Then
        upsStr(0) = "N"
        IniWrite upsDir & "UPSAPI.ini", "Settings", "Enabled", upsStr(0)
    End If
    upsApiEnabled = (upsStr(0) = "Y")
    
    If upsApiEnabled Then
        upsApiUsername = IniRead(upsDir & "UPSAPI.ini", "Settings", "Username", "")
        upsApiPassword = IniRead(upsDir & "UPSAPI.ini", "Settings", "Password", "")
        upsApiKey = IniRead(upsDir & "UPSAPI.ini", "Settings", "Key", "")
        
        If KiEmpty(upsApiUsername) Or KiEmpty(upsApiPassword) Or KiEmpty(upsApiKey) Then
            MsgBox "UPS OnLine settings missing. UPS OnLine will be disabled.", vbInformation
            upsApiEnabled = False
        End If
    End If
    
    upsInitialized = True
    UPS_Initialize = upsInitialized
End Function

Function UPS_DeliveryDate()
    UPS_DeliveryDate = ""
    
    Dim upsSvcCode As String
    
    Select Case CS32.GetVar("xINTCODE")
    Case "U11"
        upsSvcCode = "GND"
    Case "U01", "U02"
        upsSvcCode = "1DA"
    Case "U07", "U08"
        upsSvcCode = "2DA"
    Case "U21"
        upsSvcCode = "3DS"
    Case "U60", "U61"
        upsSvcCode = "1DM"
    Case "U43", "U44"
        upsSvcCode = "1DP"
    Case "U35", "U36"
        upsSvcCode = "2DM"
    End Select
    
    If Not KiEmpty(upsSvcCode) Then
        upsStr(0) = UPS_TimeInTransit
        
        UPS_DeliveryDate = Xml.ReadXPathFromText(upsStr(0), "/TimeInTransitResponse/TransitResponse/ServiceSummary[Service/Code='" & upsSvcCode & "']/EstimatedArrival/Arrival/Date/text()")
    End If
    
End Function

Function UPS_Rate() As Double
    upsInitialized = UPS_Initialize()
    If Not (upsInitialized And upsApiEnabled) Then
        Exit Function
    End If

    Dim sUpsSvcCode As String
    
    sUpsSvcCode = GetServiceCode("US", Trim(CS32.GetVar("xINTCODE")), "RATE")
    
    upsStr(0) = "<?xml version=""1.0"" encoding=""utf-8""?>" & vbLf & _
        "<soap:Envelope xmlns:soap=""http://schemas.xmlsoap.org/soap/envelope/"" xmlns:xsi=""http://www.w3.org/2001/XMLSchema-instance"" xmlns:xsd=""http://www.w3.org/2001/XMLSchema"">" & vbLf & _
        vbTab & "<soap:Header>" & vbLf & _
        vbTab & vbTab & "<UPSSecurity xmlns=""http://www.ups.com/XMLSchema/XOLTWS/UPSS/v1.0"">" & vbLf & _
        vbTab & vbTab & vbTab & "<UsernameToken>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & Xml.WriteTag("Username", upsApiUsername) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & Xml.WriteTag("Password", upsApiPassword) & vbLf & _
        vbTab & vbTab & vbTab & "</UsernameToken>" & vbLf & _
        vbTab & vbTab & vbTab & "<ServiceAccessToken>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & Xml.WriteTag("AccessLicenseNumber", upsApiKey) & vbLf & _
        vbTab & vbTab & vbTab & "</ServiceAccessToken>" & vbLf & _
        vbTab & vbTab & "</UPSSecurity>" & vbLf & _
        vbTab & "</soap:Header>" & vbLf

    upsStr(0) = upsStr(0) & _
        vbTab & "<soap:Body>" & vbLf & _
        vbTab & vbTab & "<RateRequest xmlns=""http://www.ups.com/XMLSchema/XOLTWS/Rate/v1.1"">" & vbLf & _
        vbTab & vbTab & vbTab & "<Request xmlns=""http://www.ups.com/XMLSchema/XOLTWS/Common/v1.0"">" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & "<RequestOption>Shoptimeintransit</RequestOption>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & "<SubVersion>1701</SubVersion>" & vbLf & _
        vbTab & vbTab & vbTab & "</Request>" & vbLf & _
        vbTab & vbTab & vbTab & "<Shipment>" & vbLf
        
    upsStr(0) = upsStr(0) & _
        vbTab & vbTab & vbTab & vbTab & "<Shipper>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & Xml.WriteTag("ShipperNumber", StrTran(SubStr(Alltrim(CS32.GetVar("xACCTNUMUPS")), 4), "-", "")) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & "<Address>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & Xml.WriteTag("AddressLine", Alltrim(CS32.GetVar("xFROM2"))) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & Xml.WriteTag("City", Alltrim(CS32.GetVar("xFROMCITY"))) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & Xml.WriteTag("StateProvinceCode", Alltrim(CS32.GetVar("xFROMSTATE"))) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & Xml.WriteTag("PostalCode", Alltrim(CS32.GetVar("xFROMZIP"))) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & "<CountryCode>US</CountryCode>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & "</Address>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & "</Shipper>" & vbLf

    upsStr(0) = upsStr(0) & _
        vbTab & vbTab & vbTab & vbTab & "<ShipFrom>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & "<Address>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & Xml.WriteTag("AddressLine", Alltrim(CS32.GetVar("xFROM2"))) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & Xml.WriteTag("City", Alltrim(CS32.GetVar("xFROMCITY"))) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & Xml.WriteTag("StateProvinceCode", Alltrim(CS32.GetVar("xFROMSTATE"))) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & Xml.WriteTag("PostalCode", Alltrim(CS32.GetVar("xFROMZIP"))) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & "<CountryCode>US</CountryCode>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & "</Address>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & "</ShipFrom>" & vbLf

    upsStr(1) = Alltrim(CS32.GetVar("xSHIPTO7"))
    upsStr(2) = ""
    
    On Error Resume Next
    If SubStr(upsStr(1), Len(upsStr(1)) - 2, 1) = " " Then
        upsStr(2) = Right(upsStr(1), 2)
        upsStr(1) = Left(upsStr(1), Len(upsStr(1)) - 2)
    End If
    
    upsStr(0) = upsStr(0) & _
        vbTab & vbTab & vbTab & vbTab & "<ShipTo>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & "<Address>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & Xml.WriteTag("AddressLine", Alltrim(CS32.GetVar("xSHIPTO4"))) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & Xml.WriteTag("City", upsStr(1)) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & Xml.WriteTag("StateProvinceCode", upsStr(2)) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & Xml.WriteTag("PostalCode", Alltrim(CS32.GetVar("xZIP"))) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & "<CountryCode>US</CountryCode>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & "</Address>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & "</ShipTo>" & vbLf

    upsStr(2) = ""
    'If CS32.GetVar("xUSE_ICE") = "Y" Then
    '    upsStr(2) = "" & _
    '        "<DryIce>" & vbLf & _
    '        vbTab & Xml.WriteTag("RegulationSet", "CFR") & vbLf & _
    '        vbTab & "<DryIceWeight>" & vbLf & _
    '        vbTab & vbTab & "<UnitOfMeasurement>" & vbLf & _
    '        vbTab & vbTab & vbTab & Xml.WriteTag("Code", "01") & vbLf & _
    '        vbTab & vbTab & vbTab & Xml.WriteTag("Description", "LBS") & vbLf & _
    '        vbTab & vbTab & "</UnitOfMeasurement>" & vbLf & _
    '        vbTab & vbTab & Xml.WriteTag("Weight", Trim(CS32.GetVar("xICE_WGT"))) & vbLf & _
    '        vbTab & "</DryIceWeight>" & vbLf & _
    '        "</DryIce>" & vbLf
    'End If
            
    If Not KiEmpty(upsStr(2)) Then
        upsStr(1) = "" & _
            vbTab & vbTab & vbTab & vbTab & vbTab & "<PackageServiceOptions>" & vbLf & _
            upsStr(2) & _
            vbTab & vbTab & vbTab & vbTab & vbTab & "</PackageServiceOptions>"
    End If
    
    upsStr(0) = upsStr(0) & _
        vbTab & vbTab & vbTab & vbTab & "<Package>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & "<PackagingType>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & "<Code>02</Code>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & "</PackagingType>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & "<Dimensions>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & "<UnitOfMeasurement>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & "<Code>IN</Code>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & "</UnitOfMeasurement>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & Xml.WriteTag("Length", Alltrim(CS32.GetVar("xDIM_LENGTH"))) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & Xml.WriteTag("Width", Alltrim(CS32.GetVar("xDIM_WIDTH"))) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & Xml.WriteTag("Height", Alltrim(CS32.GetVar("xDIM_HEIGHT"))) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & "</Dimensions>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & "<PackageWeight>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & "<UnitOfMeasurement>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & "<Code>LBS</Code>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & "</UnitOfMeasurement>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & vbTab & Xml.WriteTag("Weight", Alltrim(CS32.GetVar("xACT_WGT"))) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & "</PackageWeight>" & vbLf & _
        upsStr(1) & _
        vbTab & vbTab & vbTab & vbTab & "</Package>" & vbLf

    upsStr(0) = upsStr(0) & _
        vbTab & vbTab & vbTab & vbTab & "<ShipmentRatingOptions>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & "<NegotiatedRatesIndicator />" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & "</ShipmentRatingOptions>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & "<DeliveryTimeInformation>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & "<PackageBillType>03</PackageBillType>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & "</DeliveryTimeInformation>" & vbLf & _
        vbTab & vbTab & vbTab & "</Shipment>" & vbLf & _
        vbTab & vbTab & "</RateRequest>" & vbLf & _
        vbTab & "</soap:Body>" & vbLf & _
        "</soap:Envelope>" & vbLf

    If (upsStr(0) <> upsRateRq) Then
        upsRateRs = ""
    End If
        
    upsStr(1) = Xml.ReadXPathFromText(upsRateRs, "/RateResponse/Response/ResponseStatus/Code/text()")
    If (upsStr(1) <> "1") Then
        upsRateRq = upsStr(0)
        upsRateRs = UPS_SendRequest(upsRateRq, "Rate")
    End If

    Dim dblDiscChg As Double
    Dim sDelDate As String
    
    dblDiscChg = CDbl(Xml.ReadXPathFromText(upsRateRs, "/RateResponse/RatedShipment[Service/Code='" & sUpsSvcCode & "']/NegotiatedRateCharges/TotalCharge/MonetaryValue/text()"))
    If dblDiscChg > 0 Then
        Dim dblTotChg As Double, dblDiscAmt As Double
        dblTotChg = CDbl(CS32.GetVar("xTOT_CHG"))
        
        dblDiscAmt = dblTotChg - dblDiscChg
        
        CS32.SetVar "xINP_CHG", dblDiscAmt
        CS32.SetVar "xTOT_CHG", dblDiscChg
    End If
    
    
    
    sDelDate = Xml.ReadXPathFromText(upsRateRs, "/RateResponse/RatedShipment[Service/Code='" & sUpsSvcCode & "']/TimeInTransit/ServiceSummary/EstimatedArrival/Arrival/Date/text()")
    CS32.SetVar "xVDC_PHONE", sDelDate
    UPS_Rate = dblDiscChg
End Function

Function UPS_TimeInTransit()
    
    upsStr(0) = "<?xml version=""1.0"" encoding=""utf-8""?>" & vbLf & _
        "<soap:Envelope xmlns:soap=""http://schemas.xmlsoap.org/soap/envelope/"" xmlns:xsi=""http://www.w3.org/2001/XMLSchema-instance"" xmlns:xsd=""http://www.w3.org/2001/XMLSchema"">" & vbLf & _
        vbTab & "<soap:Header>" & vbLf & _
        vbTab & vbTab & "<UPSSecurity xmlns=""http://www.ups.com/XMLSchema/XOLTWS/UPSS/v1.0"">" & vbLf & _
        vbTab & vbTab & vbTab & "<UsernameToken>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & "<Username>csliu</Username>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & "<Password>123456</Password>" & vbLf & _
        vbTab & vbTab & vbTab & "</UsernameToken>" & vbLf & _
        vbTab & vbTab & vbTab & "<ServiceAccessToken>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & "<AccessLicenseNumber>CD274DA64D203C8E</AccessLicenseNumber>" & vbLf & _
        vbTab & vbTab & vbTab & "</ServiceAccessToken>" & vbLf & _
        vbTab & vbTab & "</UPSSecurity>" & vbLf & _
        vbTab & "</soap:Header>"
        
    upsStr(0) = upsStr(0) & _
        vbTab & "<soap:Body>" & vbLf & _
        vbTab & vbTab & "<TimeInTransitRequest xmlns=""http://www.ups.com/XMLSchema/XOLTWS/tnt/v1.0"">" & vbLf & _
        vbTab & vbTab & vbTab & "<Request xmlns=""http://www.ups.com/XMLSchema/XOLTWS/Common/v1.0"">" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & "<RequestOption> TNT</RequestOption>" & vbLf & _
        vbTab & vbTab & vbTab & "</Request>" & vbLf & _
        vbTab & vbTab & vbTab & "<ShipFrom>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & "<Address>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("CountryCode", "US") & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("PostalCode", Alltrim(CS32.GetVar("xFROMZIP"))) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & "</Address>" & vbLf & _
        vbTab & vbTab & vbTab & "</ShipFrom>" & vbLf & _
        vbTab & vbTab & vbTab & "<ShipTo>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & "<Address>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & "<CountryCode>US</CountryCode>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & vbTab & XmlWriteTag("PostalCode", Alltrim(CS32.GetVar("xZIP"))) & vbLf & _
        vbTab & vbTab & vbTab & vbTab & "</Address>" & vbLf & _
        vbTab & vbTab & vbTab & "</ShipTo>" & vbLf & _
        vbTab & vbTab & vbTab & "<Pickup>" & vbLf & _
        vbTab & vbTab & vbTab & vbTab & XmlWriteTag("Date", DtoS(CtoD(CS32.GetVar("xDATE")), "yyyymmdd")) & vbLf & _
        vbTab & vbTab & vbTab & "</Pickup>" & vbLf & _
        vbTab & vbTab & "</TimeInTransitRequest>" & vbLf & _
        vbTab & "</soap:Body>" & vbLf & _
        "</soap:Envelope>"
    
    If (upsStr(0) <> upsTntRq) Then
        upsTntRs = ""
    End If
        
    upsStr(1) = Xml.ReadXPathFromText(upsTntRs, "/TimeInTransitResponse/Response/ResponseStatus/Code/text()")
    If (upsStr(1) <> "1") Then
        upsTntRq = upsStr(0)
        upsTntRs = UPS_SendRequest(upsTntRq, "TimeInTransit")
    End If

    UPS_TimeInTransit = upsTntRs
End Function


Function UPS_SendRequest(upsTransXml As String, upsRqType As String) As String
    'PopStatus "Endicia Label Server", "Sending " & elsXmlPrefix
    Dim upsServer As String
    Dim upsUrl As String
    
    Dim upsTransID As String
    
    upsServer = "wwwcie.ups.com"
    upsServer = "onlinetools.ups.com"
    
    Select Case Upper(upsRqType)
    Case "RATE"
        upsUrl = "/webservices/Rate"
        upsTransID = "Rate-" & Alltrim(CS32.GetVar("xPKGID"))
    Case "TIMEINTRANSIT"
        upsUrl = "/webservices/TimeInTransit"
        upsTransID = "TimeInTransit-" & Alltrim(CS32.GetVar("xPKGID"))
    End Select
    
    elsTransID = Alltrim(elsTransID)
    elsTransID = StrTran(elsTransID, "\", "_")
    elsTransID = StrTran(elsTransID, "/", "_")
    elsTransID = StrTran(elsTransID, ":", "_")
    elsTransID = StrTran(elsTransID, "*", "_")
    elsTransID = StrTran(elsTransID, "?", "_")
    elsTransID = StrTran(elsTransID, "<", "_")
    elsTransID = StrTran(elsTransID, ">", "_")
    elsTransID = StrTran(elsTransID, "|", "_")
    
    'Save file
    XC1 = ""
    Do While fExist(upsDir & "XML\" & upsTransID & XC1 & ".xml")
        XC1 = Alltrim(Str(Val(XC1) - 1))
    Loop
    upsTransID = upsTransID & XC1
    
    Dim upsFileHnd As Integer
    Common.SaveTextToFile upsTransXml, upsTransID, "xml", upsDir & "XML", CreateUnique
    
    elsTransXml = StrTran(upsTransXml, vbTab, "")
    elsTransXml = StrTran(upsTransXml, vbLf, "")
    elsTransXml = Common.URLEncode(upsTransXml)
    
    Dim upsHttp As MSXML2.ServerXMLHTTP60
    Set upsHttp = New MSXML2.ServerXMLHTTP60
    
    upsHttp.setOption 2, 13056
    upsHttp.setTimeouts 30000, 30000, 30000, 30000
    upsHttp.Open "POST", "https://" & upsServer & upsUrl, False
    upsHttp.setRequestHeader "Content-Type", "application/x-www-form-urlencoded"
    upsHttp.send upsTransXml
    upsStr(0) = upsHttp.responseText
    
    Do While InStr(upsStr(0), "xmlns:") > 0
        upsInt(0) = InStr(upsStr(0), "xmlns:")
        upsStr(1) = SubStr(upsStr(0), upsInt(0))
        upsStr(1) = Left(upsStr(1), InStr(upsStr(1), ">") - 1)
        
        upsStr(2) = SubStr(upsStr(1), Len("xmlns:") + 1)
        upsStr(2) = Left(upsStr(2), InStr(upsStr(2), "=") - 1)
        
        upsStr(0) = StrTran(upsStr(0), "<" & upsStr(2) & ":", "<")
        upsStr(0) = StrTran(upsStr(0), "</" & upsStr(2) & ":", "</")
        
        upsStr(0) = StrTran(upsStr(0), upsStr(1), "")
        Delay (1)
    Loop
    
    upsStr(0) = SubStr(upsStr(0), InStr(upsStr(0), "<Body>") + Len("<Body>"))
    upsStr(0) = Left(upsStr(0), InStr(upsStr(0), "</Body>") - 1)
   
    UPS_SendRequest = upsStr(0)
    
    'Save response to file.
    Common.SaveTextToFile UPS_SendRequest, upsTransID & "-response", "xml", upsDir & "XML", CreateUnique
    KillStatus
    
    upsStr(1) = Xml.ReadXPathFromText(upsStr(0), "/Fault/detail/Errors/ErrorDetail/PrimaryErrorCode/Code/text()")
    If Not KiEmpty(upsStr(1)) And Not RateShop.Rating Then
        MsgBox Xml.ReadXPathFromText(upsStr(0), "/Fault/detail/Errors/ErrorDetail/PrimaryErrorCode/Description/text()") & " [" & upsStr(1) & "]", vbExclamation, "UPS OnLine Tools Error"
    End If
End Function

Function GetServiceCode(ByVal sFromCountry As String, ByVal sIntcode As String, Optional ByVal sRateOrShip As String = "RATE") As String
    Dim sSvcCode As String
    
    If sFromCountry = "US" Then
        Select Case sIntcode
            Case "U01", "U02"
                sSvcCode = "01"
            Case "U07", "U08"
                sSvcCode = "02"
            Case "U11"
                sSvcCode = "03"
            Case "U21"
                sSvcCode = "12"
            Case "U35", "U36"
                sSvcCode = "59"
            Case "U43", "U44"
                sSvcCode = "13"
            Case "U60", "U61"
                sSvcCode = "14"
            Case "U48", "U75"
                sSvcCode = "11"
            Case "U49", "U64", "U65", "U68"
                sSvcCode = "07"
            Case "U54"
                sSvcCode = "08"
            Case "U63", "U66", "U67", "U69"
                sSvcCode = "54"
            Case "U71", "U72", "U73", "U74"
                sSvcCode = "65"
        End Select
    End If
            
    GetServiceCode = sSvcCode
End Function

Function XmlWriteTag(ByVal strTagName As String, ByVal strValue As String) As String
    XmlWriteTag = "<" & strTagName & ">" & XmlSafe(strValue) & "</" & strTagName & ">"
End Function

Function XmlSafe(strValue As String) As String
    XmlSafe = strValue
    
    XmlSafe = StrTran(XmlSafe, "&", "&amp;")
    XmlSafe = StrTran(XmlSafe, "<", "&lt;")
    XmlSafe = StrTran(XmlSafe, ">", "&gt;")
    XmlSafe = StrTran(XmlSafe, """", "&quot;")
End Function

Private Function DecodeBase64(ByVal strData As String) As String
 
    Dim objXML As MSXML2.DOMDocument60
    Dim objNode As MSXML2.IXMLDOMElement
    
    ' help from MSXML
    Set objXML = New MSXML2.DOMDocument60
    Set objNode = objXML.createElement("b64")
    objNode.DataType = "bin.base64"
    objNode.Text = strData
    DecodeBase64 = objNode.nodeTypedValue
    
    ' thanks, bye
    Set objNode = Nothing
    Set objXML = Nothing
 
End Function

